// This file was generated by counterfeiter
package fakes

import (
	"sync"

	"github.com/cloudfoundry/bosh-utils/blobstore"
)

type FakeBlobstore struct {
	GetStub        func(blobID string) (fileName string, err error)
	getMutex       sync.RWMutex
	getArgsForCall []struct {
		blobID string
	}
	getReturns struct {
		result1 string
		result2 error
	}
	CleanUpStub        func(fileName string) (err error)
	cleanUpMutex       sync.RWMutex
	cleanUpArgsForCall []struct {
		fileName string
	}
	cleanUpReturns struct {
		result1 error
	}
	CreateStub        func(fileName string) (blobID string, err error)
	createMutex       sync.RWMutex
	createArgsForCall []struct {
		fileName string
	}
	createReturns struct {
		result1 string
		result2 error
	}
	ValidateStub        func() (err error)
	validateMutex       sync.RWMutex
	validateArgsForCall []struct{}
	validateReturns     struct {
		result1 error
	}
	DeleteStub        func(blobId string) (err error)
	deleteMutex       sync.RWMutex
	deleteArgsForCall []struct {
		blobId string
	}
	deleteReturns struct {
		result1 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeBlobstore) Get(blobID string) (fileName string, err error) {
	fake.getMutex.Lock()
	fake.getArgsForCall = append(fake.getArgsForCall, struct {
		blobID string
	}{blobID})
	fake.recordInvocation("Get", []interface{}{blobID})
	fake.getMutex.Unlock()
	if fake.GetStub != nil {
		return fake.GetStub(blobID)
	}
	return fake.getReturns.result1, fake.getReturns.result2
}

func (fake *FakeBlobstore) GetCallCount() int {
	fake.getMutex.RLock()
	defer fake.getMutex.RUnlock()
	return len(fake.getArgsForCall)
}

func (fake *FakeBlobstore) GetArgsForCall(i int) string {
	fake.getMutex.RLock()
	defer fake.getMutex.RUnlock()
	return fake.getArgsForCall[i].blobID
}

func (fake *FakeBlobstore) GetReturns(result1 string, result2 error) {
	fake.GetStub = nil
	fake.getReturns = struct {
		result1 string
		result2 error
	}{result1, result2}
}

func (fake *FakeBlobstore) CleanUp(fileName string) (err error) {
	fake.cleanUpMutex.Lock()
	fake.cleanUpArgsForCall = append(fake.cleanUpArgsForCall, struct {
		fileName string
	}{fileName})
	fake.recordInvocation("CleanUp", []interface{}{fileName})
	fake.cleanUpMutex.Unlock()
	if fake.CleanUpStub != nil {
		return fake.CleanUpStub(fileName)
	}
	return fake.cleanUpReturns.result1
}

func (fake *FakeBlobstore) CleanUpCallCount() int {
	fake.cleanUpMutex.RLock()
	defer fake.cleanUpMutex.RUnlock()
	return len(fake.cleanUpArgsForCall)
}

func (fake *FakeBlobstore) CleanUpArgsForCall(i int) string {
	fake.cleanUpMutex.RLock()
	defer fake.cleanUpMutex.RUnlock()
	return fake.cleanUpArgsForCall[i].fileName
}

func (fake *FakeBlobstore) CleanUpReturns(result1 error) {
	fake.CleanUpStub = nil
	fake.cleanUpReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeBlobstore) Create(fileName string) (blobID string, err error) {
	fake.createMutex.Lock()
	fake.createArgsForCall = append(fake.createArgsForCall, struct {
		fileName string
	}{fileName})
	fake.recordInvocation("Create", []interface{}{fileName})
	fake.createMutex.Unlock()
	if fake.CreateStub != nil {
		return fake.CreateStub(fileName)
	}
	return fake.createReturns.result1, fake.createReturns.result2
}

func (fake *FakeBlobstore) CreateCallCount() int {
	fake.createMutex.RLock()
	defer fake.createMutex.RUnlock()
	return len(fake.createArgsForCall)
}

func (fake *FakeBlobstore) CreateArgsForCall(i int) string {
	fake.createMutex.RLock()
	defer fake.createMutex.RUnlock()
	return fake.createArgsForCall[i].fileName
}

func (fake *FakeBlobstore) CreateReturns(result1 string, result2 error) {
	fake.CreateStub = nil
	fake.createReturns = struct {
		result1 string
		result2 error
	}{result1, result2}
}

func (fake *FakeBlobstore) Validate() (err error) {
	fake.validateMutex.Lock()
	fake.validateArgsForCall = append(fake.validateArgsForCall, struct{}{})
	fake.recordInvocation("Validate", []interface{}{})
	fake.validateMutex.Unlock()
	if fake.ValidateStub != nil {
		return fake.ValidateStub()
	}
	return fake.validateReturns.result1
}

func (fake *FakeBlobstore) ValidateCallCount() int {
	fake.validateMutex.RLock()
	defer fake.validateMutex.RUnlock()
	return len(fake.validateArgsForCall)
}

func (fake *FakeBlobstore) ValidateReturns(result1 error) {
	fake.ValidateStub = nil
	fake.validateReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeBlobstore) Delete(blobId string) (err error) {
	fake.deleteMutex.Lock()
	fake.deleteArgsForCall = append(fake.deleteArgsForCall, struct {
		blobId string
	}{blobId})
	fake.recordInvocation("Delete", []interface{}{blobId})
	fake.deleteMutex.Unlock()
	if fake.DeleteStub != nil {
		return fake.DeleteStub(blobId)
	}
	return fake.deleteReturns.result1
}

func (fake *FakeBlobstore) DeleteCallCount() int {
	fake.deleteMutex.RLock()
	defer fake.deleteMutex.RUnlock()
	return len(fake.deleteArgsForCall)
}

func (fake *FakeBlobstore) DeleteArgsForCall(i int) string {
	fake.deleteMutex.RLock()
	defer fake.deleteMutex.RUnlock()
	return fake.deleteArgsForCall[i].blobId
}

func (fake *FakeBlobstore) DeleteReturns(result1 error) {
	fake.DeleteStub = nil
	fake.deleteReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeBlobstore) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.getMutex.RLock()
	defer fake.getMutex.RUnlock()
	fake.cleanUpMutex.RLock()
	defer fake.cleanUpMutex.RUnlock()
	fake.createMutex.RLock()
	defer fake.createMutex.RUnlock()
	fake.validateMutex.RLock()
	defer fake.validateMutex.RUnlock()
	fake.deleteMutex.RLock()
	defer fake.deleteMutex.RUnlock()
	return fake.invocations
}

func (fake *FakeBlobstore) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ blobstore.Blobstore = new(FakeBlobstore)
